
/*
 * out.c
 *
 * (C) Copyright 1995 Archie L. Cobbs
 */

#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include "util.h"
#include "error.h"
#include "names.h"
#include "obj.h"
#include "asm.h"

/*
 * WriteObj()
 *
 * Write out object file
 */

void
WriteObj(FILE *fp)
{
	struct ObjHeader	header;

	header.n_magic = OBJ_HEADER_MAGIC;

/* Write incomplete header */

	if (fwrite(&header, sizeof(header), 1, fp) != 1)
	{
		perror("fwrite");
		cerror("can't write object header");
	}

/* Write text, data, (bss) segments */

	header.n_text = EmitSegDump(fp, CodeSegment);
	header.n_data = EmitSegDump(fp, DataSegment);
	header.n_bss = gAddress[BssSegment];

/* Write text, data relocation */

	header.n_treloc = RelocDumpEntries(fp, CodeSegment);
	header.n_dreloc = RelocDumpEntries(fp, DataSegment);

/* Write global symbols */

	header.n_symbols = ExportDump(fp);

/* Write names database */

	header.n_strings = NamesDump(fp, gObjNames);

/* Rewrite completed header */

	rewind(fp);
	if (fwrite(&header, sizeof(header), 1, fp) != 1)
	{
		perror("fwrite");
		cerror("can't write object header");
	}
}

