
*
* This Is A Comment
*

;;;
;;; Set tabs to eight
;;;

COUT		=	$fded		; Apple style hex
COUT1		=	0xfdf0		; C-style hex numbers
alternating_bit	=	%10101010	; $AA in binary

; We allow full C-style expressions on constants, with one difference.
; When doing expressions, '[' and ']' are used for grouping rather
; than parentheses, because otherwise how would you interpret this:
;
;   JMP (label + 4)
;
; It might mean indirect reference or it might just mean label + 4.
; So we interpret as the former; for the latter do this:
;
;   JMP [lable + 4]
;

bignum		=	[1<<30]
abc		=	[bignum / [1 << 16] ] ^ 0xFFFF

; Import these symbols

		.import	extern_sym1
		.extern	extern_sym2	; ".extern" same as ".import"

; Import these, but reference addresses as zero page

		.zimport extern_zp

; Make these symbols globally viewable

		.export	bignum
		.global	label1		; ".global" same as ".export"

; We default into to the CODE segment

		lda	#1

; Labels can have a colon or not...

label1:
lable2  	lda     #$20
		bcc     label3
		ADC     $33

		lda	#'a'		; hibit defaults to zero
		.hibit	1
		lda	#'a'		; now hibit is one
		.hibit	0

		lsr			; implied operand -- leave blank
		nop			; comment
label3		dec	extern_sym1+4	; reference external symbol
		dec	extern_zp	; reference external zero-page symbol
		lsr     extern_undef-4	; undefined, so becomes external 
		lda	#<extern_sym1+8	; "reasonable" arithmetic is allowed
		lda	#>extern_sym1+8 ;   on external symbols (add & subtract)
		ldx	#<COUT
		ldy	#>COUT

; OK, let's go to the DATA segment now

		.data

; ".word" stores a 16 bit quantity little endian (native to 6502)

		.word   COUT,12345, %110101, 0177, $af03, 0x63734

; ".dbyt" stores a 16 bit quantity big endian

		.dbyt	COUT

; ".long" stores a 32 bit quantity, little endian

		.long	65535

; ".float" stores 5 byte AppleSoft style floating point constants
; Note that an expression like 1/2 is evaluated as a integer, then cast.
; Floating point expressions are not allowed yet, sorry.

		.float	0
		.float	1, 0.5, 5/2
		.float	1.41421356237

; We can do "reasonable" arithmetic on local symbols

		.dbyt	_morespace - _emptyspace

; String stuff -- note that ".hibit" affects these, except octal & hex chars

		.asciz  "asfs\tdf"
		.ascii	" \n\t\v\b\r\f\a\e\\\"\033\xAA "

; ".dci" is "dextral character inverted" a la Merlin

		.dci    "quite a long string my friend, indeed it is"

; cut down on the clutter...

		.expand	0
		.ascii  "quite a long string my friend, indeed it is"

; Now go to the BSS segment (uninitialized data -- always comes out zero)

		.bss
_emptyspace 	.space  13

; Align it if you want...

		.align	4
_morespace	.space	3

; ".ds" is same as ".space"

_morespace2	.ds	3

